<?
//        the software is GNU licensing dependent.
//  Copyright (C) 2002,2003 Stichting schoolLAN (R), Arnhem, Netherlands

//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTLY; without even the implied warranty of
//  MERCHANTABILITY of FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


/*
 * readBatch ($filenaam);
 * Leest een batch bestand in en returned een array met daarin de batch gegevens.
 * 
 * Aanroepen met als argument de bestandsnaam van het batch bestand
 *
 * Wanneer er iets fout gaat returned hij een errorcode
 * Na aanroep moet er dus gecontroleerd worden of het resultaat een array is, 
 * zo ja, dan is het goed, anders moet je in $errors[] de bijbehorende error-code 
 * opzoeken.
 * Voorbeeld:
 * $res = readBatch("batch.txt");
 * if (is_array($res)) {
 * 	//goed	
 * } else {
 *	$error = $errors[$res];
 * }
 * 
 *
 * De batch files zijn op de volgende manier opgebouwd:
 * Regel 1: namen van de verschillende kolommen
 * Rest: inhoud van de verschillende kolommen
 * Een lege regel of een regel die begint met een # wordt genegeerd (commentaar dus)
 *
 * Voorbeeld:
 * username,naam,paswoord,bla
 * #############################
 * pkrebber,Pim Krebbers,geheim,hjgfd
 * mede,Mirko van Ede,geheim,jhds
 * jkoppers,Joost Koppers,geheim,hjsa
 * rweede, Renske Weeda, geheim,yue
 *
 * De elementen worden automatisch gestript van spaties en tabs aan begin en 
 * eind (www.php.net/trim)
 * 
 * 
 */
function readBatch ($filenaam) {
	$formatSet = false;
	$batch = array();
	if ($file = @file($filenaam)) {
		array_walk ($file, 'my_trim');
		foreach ($file as $line) {
			if ($line != '' && ! ereg("^#",$line)) {
				if (! $formatSet) {
					//lees formaat in
					$format = explode(",",$line);
					array_walk ($format, 'my_trim');
					$nrElements = count($format);
					$formatSet = true;
				} else if (! ereg("^#",$line)) {
					//het is een batch entry
					$entry = explode(",",$line);
					array_walk ($entry, 'my_trim');
					
					if (count($entry) != $nrElements) {
						return 11; //Fout opgetreden bij lezen van entry: verkeerd aantal elementen
					} else {
						$temp = array();
						for ($i = 0; $i < $nrElements; $i ++) {
							$temp[$format[$i]] = $entry[$i];
						}
						$batch[] = $temp;
					}
				}
			}			
		}
		return $batch;
	} else 
		return 12; //Fout opgetreden bij het lezen van het batch bestand
} /* readBatch($filenaam) */

/*
 * Hulp functie om ongewenste spaties te verwijderen uit de input
 * In combinatie met array_walk($rij,'my_trim') worden alle elementen in $rij 
 * door de functie trim bewerkt. Zie www.php.net/trim voor werking van trim
 */
function my_trim (&$item1, $key) {
    $item1 = trim($item1);
} /* my_trim */


?>