<?php
//        the software is GNU licensing dependent.
//  Copyright (C) 2002,2003 Stichting schoolLAN (R), Arnhem, Netherlands

//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTLY; without even the implied warranty of
//  MERCHANTABILITY of FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

function getPostVar($index='') {
/*
 * Deze functie geeft toegang tot de POST-variabelen zoals die door een form doorgegeven
 * kunnen worden.
 *
 * Returned de gehele POST-variabelen array als $index leeggelaten wordt.
 * Anders returned hij de opgegeven POST-variabele als deze bestaat. 
 * Zo niet returned hij een lege string.
 */

	// bepalen waar post-variabelen worden opgeslagen, dit is namelijk afhankelijk van de 
	// PHP-versie en instellingen
	if (isset($_POST))
		$__POST = $_POST;
	else {
		global $HTTP_POST_VARS;
		$__POST = $HTTP_POST_VARS;
	}
	
	// als $index niet opgegeven is geef je de hele POST-variabelen array terug
	if ($index == '')
		return ($__POST);
	
	// anders kijk je of $index een element is van de POST-variabelen
	if (isset($__POST[$index]))
		return ($__POST[$index]);
	else
		return '';
} /* getPostVar */

function getGetVar($index='') {
/*
 * Deze functie geeft toegang tot de GET-variabelen zoals die door een url of een form doorgegeven
 * kunnen worden.
 *
 * Returned de gehele GET-variabelen array als $index leeggelaten wordt.
 * Anders returned hij de opgegeven GET-variabele als deze bestaat. 
 * Zo niet returned hij een lege string.
 */

	// bepalen waar post-variabelen worden opgeslagen, dit is namelijk afhankelijk van de 
	// PHP-versie en instellingen
	if (isset($_GET))
		$__GET = $_GET;
	else {
		global $HTTP_GET_VARS;
		$__GET = $HTTP_GET_VARS;
	}
	
	// als $index niet opgegeven is geef je de hele GET-variabelen array terug
	if ($index == '')
		return ($__GET);
	
	// anders kijk je of $index een element is van de GET-variabelen
	if (isset($__GET[$index]))
		return ($__GET[$index]);
	else
		return '';
} /* getGetVar */

function getFileVar($index='') {
/*
 * Deze functie geeft toegang tot de POST FILE-variabelen zoals die door een url of een form doorgegeven
 * kunnen worden.
 *
 * Returned de gehele POST FILE-variabelen array als $index leeggelaten wordt.
 * Anders returned hij de opgegeven POST FILE-variabele als deze bestaat. 
 * Zo niet returned hij een lege string.
 */

	// bepalen waar post-variabelen worden opgeslagen, dit is namelijk afhankelijk van de 
	// PHP-versie en instellingen
	if (isset($_FILES))
		$__FILE = $_FILES;
	else {
		global $HTTP_POST_FILES;
		$__FILE = $HTTP_POST_FILES;
	}
	
	// als $index niet opgegeven is geef je de hele POST FILE-variabelen array terug
	if ($index == '')
		return ($__FILE);
	
	// anders kijk je of $index een element is van de POST FILE-variabelen
	if (isset($__FILE[$index]))
		return ($__FILE[$index]);
	else
		return '';
} /* getFileVar */

?>