<?
//        the software is GNU licensing dependent.
//  Copyright (C) 2002,2003 Stichting schoolLAN (R), Arnhem, Netherlands

//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.

//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTLY; without even the implied warranty of
//  MERCHANTABILITY of FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General License for more details.

//  You should have received a copy of the GNU General Public License
//  along with this program; if not write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

function getTeam() {
/*
 * Deze functie geeft informatie terug over de teamleden
 *
 * Returned een array met daarin de teamleden. Elk teamlid wordt gerepresenteerd door een array met 2 elementen. 
 * 0e element is zijn volledige naam, 1e element is zijn gebruikersnaam
 */
	$users = array();

	$mem = exec ("/bin/grep '^team:' /etc/group");
        $memX = explode (":", $mem);
        $memX = explode (",", $memX[3]);
        foreach ($memX as $user)
        {
	    //Doe een grep in de //etc/passwd om de volledige naam te achterhalen
	    $grep = exec ("grep '^".$user.":' /etc/passwd");
	    $grepX = explode (":", $grep);
				
	    if ($grep != '' && $grepX[0] == $user && $grepX[2] >= 8000 && $grepX[2] < 8100 && substr($grepX[4],0,16) != 'Niet verwijderen') {

		//Sla de naam op in de array
		$naam = array();
		$naam[0] = $grepX[4];
		$naam[1] = $user;
		$users[] = $naam;
	    }
	}
	//moeten de teamleden gesorteerd worden?
	//sort($users,SORT_STRING);
	
	return $users;	
}/*getTeam*/

function getVolUsernaam ($user) {
/*
 * Deze functie geeft de volledige naam terug van gebruiker met gebruikersnaam $user
 *
 * Returned een string met de volledige naam
 */
 
	//Doe een grep in de //etc/passwd om de volledige naam te achterhalen
	$grep = exec ("grep '^".$user.":' /etc/passwd");
	$grep = explode (":", $grep);
	
	return $grep[4];	  
}/*getVolUsernaam*/

function isTeam ($user) {
/*
 * Deze functie kijkt of de gebruiker met gebruikersnaam $user een teamlid is
 *
 * Returned een boolean, true of false
 */
 
	$mem = exec ("/bin/grep '^team:' /etc/group");
        $memX = explode (":", $mem);
        $memX = explode (",", $memX[3]);

	foreach ( $memX as $naam ) {
		if ($naam==$user) {
			return true;	
		}
	}
	return false;
}

function isUser($user) {
/*
 * Deze functie kijkt of de gebruiker met gebruikersnaam $user een gebruiker op het systeem is
 *
 * Returned een boolean, true of false
 */
 
 	//als het een teamlid is, dan is het een gebruiker van het systeem
	if (isTeam($user))
		return true;
	
	//als het ' groep*'  is dan voldoet het ook als referentie
	if (preg_match("|^groep[0-9]$|",$user))
		return true;
	
        $null = exec ( "/bin/grep '^groep[0-9]:' /etc/group", $groepen);
	foreach( $groepen as $groep ) {
		/*We gaan alle groepen langs */
		$mems = explode( ":", $groep);
		$mems = explode( ",", $mems[3]);
		foreach ( $mems as $naam ) {
			if ($user == $naam) {
				return true;
			}			
		}	
	}
	return false;
} /* isUser */

function inGroepen ($user) {
/*
 * Deze functie kijkt in welke groepen de gebruiker zit
 *
 * Returned een array met daarin de groepen  
 */
 
	/* Als de user lid is van team, dan is het snel bekeken */
	
	if (isTeam($user)) {
		return FALSE;
		exit;
	}

        $null = exec ( "/bin/grep '^groep[0-9]:' /etc/group", $groepen);
	$groepen = array();
	foreach( $groepen as $groep ) {
		/*We gaan alle groepen langs */
		$mems = explode( ":", $groep);
		$mems = explode( ",", $mems[3]);
		foreach ( $mems as $naam ) {
			if ($user == $naam) {
				$groepen[] = $groep[0];
			}			
		}	
	}
	return $groepen;
}/*inGroepen*/

function getLeerlingen($groepnr) {
/* 
getLeerlingen(x) geeft een rij met users van de betreffende groep
getLeerlingen(all) geeft een rij met op elke plek een rij met leerlingen van de betreffende groep
*/

	$users = array();
	$groepen = array();
        $null = exec("/bin/grep '^groep[1-9]:' /etc/group", $groepen);
	foreach ( $groepen as $groep ) {
		/* We gaan alle groepen langs */
		$mems = explode( ":", $groep);
		$groep = $mems[0];
		$mems = explode( ",", $mems[3]);
		$namen = array();
		foreach ( $mems as $user ) {
			if ($user == $groep) { continue ; };
			$grep = exec("grep '^".$user.":' /etc/passwd");
			$grep = explode(":", $grep);
			if ($grep != "" && $grep[2] >= 8100 && $grep[2] < 9000) {
			/* Sla de naam op in de array */
				$naam = array();
				$naam[0] = $grep[4];
				$naam[1] = $user;
				$namen[] = $naam;
			}			
		}	
		$users[$groep] = $namen;
	}
	
	switch (strtolower($groepnr)) {
	  case 'all':
	    /* We moeten alle groepen laten zien */
	    return $users;
	    break;	  
	  default:
	    return $users["groep".$groepnr];
	    break;
	}	
}/*getLeerlingen*/

?>

