#       the software is GNU licensing dependent.
#  Copyright (C) 2002,2003 Stichting schoolLAN (R), Arnhem, Netherlands

#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.

#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTLY; without even the implied warranty of
#  MERCHANTABILITY of FITNESS FOR A PARTICULAR PURPOSE. See the
#  GNU General License for more details.

#  You should have received a copy of the GNU General Public License
#  along with this program; if not write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# bestandsnaam: aps.sh
# Willem-Jan Derks, 2003
#
# dit bestand wordt door giplan aangeroepen en wordt gebruikt om 
# software paketten aan computers toe te voegen. 
#
# lokatie: \home\httpd\gipln\systeem\aps.sh



case $1 in


# optie 1 wordt gebruikt om een lijst te maken 
# van de computers en de bijbehorende applicaties.
	1)	#genereer een lijst met aps die op de computer zitten
		cd /tftpboot/win98   	#pad met computer 
		for i in `ls`			#Ga alle bestanden af
		do
			if test -d $i 		#als bestand een directory is
			then
				if [ $i !=  "share" ] # het mag niet de share directory zijn.
				then
					cd $i
					if test -d aps # kijk of de directory aps aanwezig is.
					then 
						echo "computer:$i" # geef de computernaam weer als bijvoorbeeld ict-visie:
						for j in `ls ./aps` # onder de computernaam komen de bijbehorende applicaties.
						{
						echo $j
						} 
					fi
					cd ..
				fi
			fi
		done
		;;
	
# optie 2 wordt gebruikt om de beschikbare paketten weer te geven.
	2) #leest alle geinstalleerde paketten	
		for i in `ls /extra/share/Win95/programs/team/setup/`
		do		
			echo $i
		done
		;;
	
#optie 3 wordt gebrukt om nieuwe instellingen per pakket en computer weg te schrijven.
	3) #schrijft nieuwe instellingen weg regel voor regel
		echo "" > $2
		;;

#nadat de nieuwe instellingen verwerkt zijn wordt setup.ref ge-update.
#setup.ref wordt na de installatie als c:\setup.bat neergezet
#en wordt de eerste keer dat de pc na het terugzetten van het image gestart.
#als de directory aps niet aanwezig is wordt die hier aangemaakt
#zodat er met elke nieuwe pc alleen een image gemaakt hoeft te worden van
#de nieuwe pc
	4) #update setup.ref
		cd /tftpboot/win98
		for i in `ls`
        do
        if test -d $i #als bestand een directory is
                then
                cd $i
                if test -d aps # kijk of de directory aps aanwezig is en update setup.ref
                then

                        (cd aps
                        ls | awk '{FS=";"} BEGIN { printf(echo "@echo off\r\n") }
                        {
                                printf("p:\\team\\setup\\%s\r\n",$1)
                        }
                                END {printf("exit\r\n")}'
                        ) >setup.ref

                else
                        mkdir aps
                fi
                cd ..
        fi
        done
		;;
		
# Met optie 5 worden de bestaande instellingen gewist,
# dit wordt gestart voor het schrijven van de nieuwe instellingen.
# instellingen -> giplan -> instellingen
	5) #rm aps directory	
		
		cd /tftpboot/win98   #pad met computer 
		for i in `ls`	#Ga alle bestanden af
		do
			if test -d $i #als bestand een directory is
			then
				cd $i
				if test -d aps # kijk of de directory aps aanwezig is en update setup.ref
				then 
					cd aps
					rm *.* -f
					cd ..
				fi
				cd ..
			fi
		done
		
esac
