<?php
/*----------------------------------------------------------------------
 * tabdemo.php - Voorbeeld van manipuleren tad-delimited datafiles in php
 * peter fokker - 2003-07-31 <peter@schoollan.nl>
 */
//$datfile = "/home/sites/site115/web/tabdemo.dat";
$datfile = "/home/httpd/passwd.conf";
$create = "Create";
$update = "Update";

$pageheader =	"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n".
		"<html>\n".
		"  <head>\n".
		"    <meta name=\"MSSmartTagsPreventParsing\" content=\"TRUE\">\n".
		"    <title>tabdemo.php - voorbeeld van manipuleren tab-delimited files in php</title>\n".
		"  </head>\n";

$pagefooter = 	"    &nbsp;<p>&nbsp;\n".
		"    <hr>\n".
		"    <address><font size=\"-1\">Commentaar naar ".
		"<a href=\"mailto:peter@schoollan.nl\">peter</a></font></address>\n".
		"  </body>\n".
		"</html>\n";

echo $pageheader;

$action = $HTTP_GET_VARS['action'];

if ($action == "$create") {
    // create dummy data file, with 4 fields:
    // field 0 = unique id
    // field 1 = userid
    // field 2 = full name
    // field 3 = plain text password (to be md5()'ed
    //
    $dummy = array(	"1	foo	Foo Bar	secret",
			"2	bar	Bar Quux	unkown",
			"3	baz	Baz Whairl	stub");
    $s = "";

    foreach ($dummy as $u) {
	$urec = explode("\t",$u);
	$s .= 	$urec[0]."\t".
		$urec[1]."\t".
		$urec[2]."\t".
		md5($urec[3])."\n";
	}
    umask(07);
    $fp = fopen($datfile,"w");
    $n = strlen($s);
    fwrite($fp,$s,$n);
    fclose($fp);
    chmod($datfile,0640);
    echo "Created $datfile with this data:\n<p>\n";
    echo "<pre>$s</pre>";
    }
elseif ($action == "$update") {
    //van intval heb ik een wijziging gemaakt naar strval
	$id = intval($HTTP_GET_VARS['id']);
    $name = substr($HTTP_GET_VARS['name'],0,20);
    $pwd1 = md5($HTTP_GET_VARS['pwd1']);
    $pwd2 = md5($HTTP_GET_VARS['pwd2']);
    if ($pwd1 != $pwd2)
	echo "<h2>Oops. Different passwords for user $id (".htmlspecialchars($name)."). Try again</h2>";
    else {
	// at this point we need to update the data file
	// strategy:
	// open file for input
	// for all lines in file
	//    get line in memory
	//    if this line belongs to id $id, update line
	// close file for input
	// open file for output
	// for all lines in memory
	//    output line to file
	// close file
	if (!($fp = fopen($datfile,"r"))) {
	    echo 	"Can't open file $datfile\n".
			"Please create the datafile first with:\n<p>\n".
			"<a href=\"$PHP_SELF?action=$create\">$PHP_SELF?action=$create</a><p>\n".
			"Have a nice day!\n";
	    echo $pagefooter;
	    exit;
	    }
	$s = "";
	while (!feof ($fp)) {
            $buffer = rtrim(fgets($fp, 4096));
	    $arecord = explode("\t",$buffer);
	    if ($id == intval($arecord[0])) {
		$arecord[2] = strtr($name,"\t\n","__"); // don't get fooled by spurious tabs and newlines
		$arecord[3] = $pwd1;	// or $pwd2, they were equal before and already md5()'ed
		$buffer = $arecord[0]."\t".
			  $arecord[1]."\t".
			  $arecord[2]."\t".
			  $arecord[3];
		echo "<h2>Password for user $id ($name) updated</h2>\n";
		}
	    $s .= $buffer."\n";
	    }
	fclose($fp);
	$fp = fopen($datfile,"w");
	$n = strlen($s);
	fwrite($fp,$s,$n);
	fclose($fp);
	}
    }

/*
 * Now always show the contents of the file, never mind we've just created/updated it
 */
if (!($fp = fopen($datfile,"r"))) {
	echo 	"Can't open file $datfile\n".
		"Please create the datafile first with:\n<p>\n".
		"<a href=\"$PHP_SELF?action=$create\">$PHP_SELF?action=$create</a><p>\n".
		"Have a nice day!\n";
	echo $pagefooter;
	exit;
    }
$s=	"<table border=\"1\" cellpadding=\"10\">\n".
	" <tr>\n".
	"  <td>nr</td>\n".
	"  <td>uid</td>\n".
	"  <td>name</td>\n".
	"  <td>new passwd</td>\n".
	"  <td>new passwd again</td>\n".
	"  <td>&nbsp;</td>\n".			// column for update button
	" </tr>\n";

while (!feof ($fp)) {
        $buffer = rtrim(fgets($fp, 4096));
	//
	// Note: at this point we should filter out comment lines & empty lines
	// something like this:
	// $s = trimallleadingspaces($buffer)
	// if stringlength($s) <= 0 or $s[0] = "#" then ignore line else process line
	// Left as an exercise for the reader...
	//
        $arecord = explode("\t",$buffer);
	/////
    $id = intval($arecord[0]);
	$uid = htmlspecialchars($arecord[1]);
	$name = htmlspecialchars($arecord[2]);
	// old pwd makes no sense because it is md5()'ed
	if ($id > 0) 
	    $s .=
		" <form action=\"$PHP_SELF\" method=\"GET\">\n".
		" <tr>\n".
		"  <td>\n".
		"   <input type=\"hidden\" name=\"id\" value=\"$id\">\n".
		"   $id\n".
		"  </td>\n".
		"  <td>$uid</td>\n".
		"  <td>\n".
		"   <input type=\"text\" name=\"name\" size=\"20\" value=\"$name\">\n".
		"  </td>\n".
		"  <td>\n".
		"   <input type=\"password\" name=\"pwd1\" size=\"20\" value=\"\">\n".
		"  </td>\n".
		"  <td>\n".
		"   <input type=\"password\" name=\"pwd2\" size=\"20\" value=\"\">\n".
		"  </td>\n".
		"  <td>\n".
		"   <input type=\"submit\" name=\"action\" value=\"$update\">\n".
		"  </td>\n".
		" </tr>\n".
		" </form>\n";
	}
$s .= "<table>\n";
echo $s;
echo $pagefooter;
?>
